#pragma once

#include "CPP.H"

class MP3Info
{

public:

  // id3 info
  
  bool id3_found;
  std::string artist;
  std::string title;
  std::string album;
  std::string year;
  std::string comment;
  int genre;

  // mpeg info

  int level;  // -1 => 2.5
  int layer;
  bool vbr;
  float bit_rate;
  uint4 num_frames;
  uint4 sample_rate;
  int  channel_mode;
  bool error_protection;
  bool copyright;
  bool original;
  int  emphasis;
  uint4 file_size;
  float duration;
  
  static const char *emphasis_txt[];
  static const char *channel_mode_txt[];
  static const char *genre_txt[];  

  MP3Info() { id3_found = false; }

  // return 0 iff ok
  int get(const char *filename);

  void print(std::ostream &os = std::cout);
};
