#pragma once

#include "CPP.H"
#include <mpd/client.h>

struct MPD_Status
{
  int volume;
  bool repeat;
  bool shuffle;
  int state;     // MPD_STATE_UNKNOWN, MPD_STATE_STOP, MPD_STATE_PLAY, MPD_STATE_PAUSE
  int elapsed_time;
  int total_time;  
  int bit_rate;
  int song_pos;
  int queue_len;
  
  MPD_Status();

  void print();
  int update(mpd_connection *mpd_conn);
};

// useful mpd commands

extern int mpd_repeat(mpd_connection *mpd_conn, bool rep);
extern int mpd_pause(mpd_connection *mpd_conn, bool pause);
extern int mpd_stop(mpd_connection *mpd_conn);
extern int mpd_play(mpd_connection *mpd_conn);
extern int mpd_clear(mpd_connection *mpd_conn);
extern int mpd_previous(mpd_connection *mpd_conn);
extern int mpd_next(mpd_connection *mpd_conn);
extern int mpd_seek(mpd_connection *mpd_conn, int song_pos, int time);
extern int mpd_update(mpd_connection *mpd_conn);

extern int mpd_add(mpd_connection *mpd_conn, std::vector<std::string> &titles);

