#pragma once

#include "CPP.H"
#include <random>
#include <vector>
#include "PlayMode.H"
#include "PlayNode.H"

struct PlayList
{
  std::string display_name;
  std::string path;
  std::vector<std::string> list;   // file names
};

class PlayLists
{
public:

  PlayLists(const std::string &hd) : home_dir(hd) { } 
  
  // read all lists from directory
  int read(const std::string &dir);

  // add a list of songs with name
  void add_list(const std::string &display_name, const std::vector<std::string> &songs);
  
  // create display name and song list from playlist
  void create_song_list(int index, const PlayNode *tree, RNG &rng, bool shuffle,
                        const PlayMode &play_mode,
                        std::string &display_name, std::vector<std::string> &songs);

  // how many lists?
  int get_list_num() const { return lists.size(); }

private:

  // read new list from file; >=0: ok (new list size), <0: error
  int add_list(const std::string &display_name, const std::string &full_path);

  std::string home_dir; // music home directory
  std::vector<PlayList> lists;
};
