#include "PlayMode.H"
#include <iostream>

using namespace std;

bool PlayMode::select(int g_val, int l_val) const
{
  if (g_val < -1 || g_val > 2 || l_val < -1 || l_val > 1)
    ERR("g/l out of range: " << g_val << " " << l_val);
  
  switch (state) {
  case MODE_GOOD:
    return g_val == 2;
  case MODE_GOOD_LIGHT:
    return g_val == 2 && l_val == 1;
  case MODE_GOOD_HEAVY:
    return g_val == 2 && l_val == 0;
  case MODE_OK:
    return g_val >= 1;
  case MODE_OK_LIGHT:
    return g_val >= 1 && l_val == 1;
  case MODE_OK_HEAVY:
    return g_val >= 1 && l_val == 0;
  case MODE_EXP:
    return g_val < 0 || l_val < 0;
  case MODE_ANY:
    return true;
  case MODE_BAD:
    return g_val == 0;
  default:
    ERR("unknown state");
  };

  return true;
}
